import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { FireForceComponent } from './fire-force/fire-force.component';
import { LinkageForcesComponent } from './linkage-forces/linkage-forces.component';
import { WaterCollectionComponent } from './water-collection/water-collection.component';



const routes: Routes = [
  { path: 'water', component: WaterCollectionComponent },
  { path: 'fireForce', component: FireForceComponent },
  { path: 'linkageForces', component: LinkageForcesComponent }
];



@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule]
})
export class DataCollectionRoutingModule { }
