import { Component, OnInit, Inject } from '@angular/core';
import {MatTreeFlatDataSource, MatTreeFlattener} from '@angular/material/tree';
import {FlatTreeControl} from '@angular/cdk/tree';
import { HttpClient } from '@angular/common/http';
import {MatDialog, MatDialogRef, MAT_DIALOG_DATA} from '@angular/material/dialog';
import {FormControl} from '@angular/forms';
import { MatSnackBar } from '@angular/material/snack-bar';
@Component({
    selector: 'editunitinfo',
    templateUrl: './editunitinfo.component.html',
    styleUrls: ['./unit-information.component.scss']
  })
  export class EditUnitInfo {
    templatenamedefault = this.data.unitInformation.name
    myControl = new FormControl();
    constructor(private http: HttpClient,public dialogRef: MatDialogRef<EditUnitInfo>,@Inject(MAT_DIALOG_DATA) public data) {}
    onNoClick(): void {
      this.dialogRef.close();
    }

    onSubmit(value){
        this.http.put(`/api/BasicCategories/${this.data.unitInformation.id}`,{
            id: this.data.unitInformation.id,
            name: value.templatename, 
            enabled: Boolean(Number(value.enable)),
        }).subscribe(data=>{
            this.dialogRef.close('ooo');
        })
    }
  }