import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { PaginatorComponent } from './paginator.component';
import { MatPaginatorIntl, MatPaginatorModule } from '@angular/material/paginator';
import { myPaginator } from './my-paginator'
import { UiModule } from '../ui.module';


@NgModule({
  declarations: [PaginatorComponent],
  imports: [
    CommonModule,
    MatPaginatorModule
  ],
  providers: [ { provide: MatPaginatorIntl, useValue: myPaginator() } ]
})
export class PaginatorModule { }
